{$A+} {Word allign}
{$F-} {Use NEAR calls}
{$G-} {8086 instructions}
{$D-} {Strip debug information}
{$B-} {Short boolean evaluation}
{$L-} {Do not generate local symbols information}
{$M, 1024,0,0}


PROGRAM Friday13th_INTRO_4;


CONST
  Copyright : STRING[27] = 'cTgfwn|0y'#26'\Ǝ';
                          {'Code & Gfx by The GodFather';}
  NoFPoints = 400;
  StarSpeed = 1;



{$I LOGO13_1.PAS}
{$I PICT13_1.PAS}
{$I INTRO13.INC}


TYPE
  TPicture = ARRAY[1..PictureX*PictureY] OF Byte;

VAR
   Pict: TPicture;
   Stars: TPoints3D;




{---------------------------------------------------------------------------}
PROCEDURE InitStars;
VAR Index:Integer;
BEGIN
  Randomize;
  FOR Index := 1 TO NoFPoints DO
  BEGIN
    Stars[Index].X := (Random(2000)-1000);
    Stars[Index].Y := (Random(2000)-1000);
    Stars[Index].Z := (Random(400)+1);
    Stars[Index].OnScreen := False;
  END;
END;






{---------------------------------------------------------------------------}
PROCEDURE MoveStars;
CONST
  ExpF = 25;

VAR
  TempX     : Integer;
  TempY     : Integer;
  StarsX    : Integer;
  StarsY    : Integer;
  StarsZ    : Integer;
  Index     : Integer;
  TempColor : Byte;
  DrawStar  : Boolean;
  OnScreen  : Boolean;


  PROCEDURE CalcTempXY; NEAR;
  BEGIN
    TempX := (StarsX * Expf) DIV StarsZ + Max_X_DIV_2;
    TempY := (StarsY * Expf) DIV StarsZ + Max_Y_DIV_2;
  END;

  FUNCTION OK:Boolean;
  VAR
    hardX,hardY: Byte;
    softX,softY: Byte;
    Symbol,Curr: Byte;
    Off        : Integer;
    O_K        : Boolean;

  BEGIN
    OK := True;
    hardX := TempX DIV FontX;
    hardY := TempY DIV FontY;
    softX := TempX MOD FontX;
    softY := TempY MOD FontY;
    Off := hardY*80+hardX+1;
    Symbol := Ord(Logo[Off].Ch);
    Curr := Font8x14^[Symbol,SoftY+1];
    O_K := (Curr AND BitMasc[SoftX]) <> BitMasc[SoftX];

    IF (TempX > 460) AND (TempX < 582) AND
       (TempY > 130) AND (TempY < 265)
         THEN BEGIN
                softX := TempX - 460;
                softY := TempY - 130;
                O_K := (Pict[Pred(softX) * PictureY + softY]) = 0;
              END;

    OK := O_K;
  END;


BEGIN
  REPEAT
    VRetrace;
    FOR Index := 1 TO NoFPoints DO
    BEGIN
      DrawStar := True;
      StarsX := Stars[Index].X;
      StarsY := Stars[Index].Y;
      StarsZ := Stars[Index].Z;
      OnScreen := Stars[Index].OnScreen;

      CalcTempXY;
      IF OnScreen THEN PutPixel(TempX,TempY,0);

      StarsZ := StarsZ - StarSpeed;
      IF (StarsZ <= 0) THEN StarsZ := 400;
      Stars[Index].Z := StarsZ;

      IF StarsZ  < 300 THEN TempColor := $7;
      IF StarsZ  < 100 THEN TempColor := $F;
      IF StarsZ >= 200 THEN TempColor := $8;

      CalcTempXY;
      IF (TempX < 0) OR (TempX > Max_X) OR
         (TempY < 0) OR (TempY > Max_Y) THEN DrawStar := False;

    { OnScreen := GetPixel(TempX,TempY) = 0; }

      IF DrawStar = False
        THEN OnScreen := False
        ELSE OnScreen := OK;

      Stars[Index].OnScreen := OnScreen;
      IF DrawStar THEN
        IF OnScreen THEN PutPixel(TempX,TempY,TempColor);
    END;
  UNTIL KeyPressed;
END;








{---------------------------------------------------------------------------}
PROCEDURE DeCompressPicture;
VAR BufIndex,PictIndex:Word;
    Color,Counter:Byte;
BEGIN
  BufIndex := 0;
  PictIndex := 1;
  REPEAT
    Inc(BufIndex);
    Counter := Picture[BufIndex];
    IF Counter >= 240
      THEN BEGIN
             Color := Counter - 240;
             Pict[PictIndex] := Color;
             Inc(PictIndex);
           END
      ELSE BEGIN
             Inc(BufIndex);
             Color := Picture[BufIndex];
             FillChar(Pict[PictIndex],Counter,Color);
             Inc(PictIndex,Counter);
           END;
  UNTIL PictIndex >= SizeOf(Pict);
END;


PROCEDURE ShowPicture;
VAR I,R:Integer; Col:Byte;
BEGIN
  FOR R := PictureY DOWNTO 1 DO
    FOR I := PictureX DOWNTO 1 DO
    BEGIN
      Col := Pict[Pred(I) * PictureY + R];
      IF Col <> 0 THEN PutPixel(I+PictX,R+PictY,Col);
    END;
END;
{---------------------------------------------------------------------------}







{------------------------------ MAIN PROGRAM -------------------------------}
BEGIN
  InitSTARS;
  DeCompressPicture;

  Font8x14 := GetFontAddress;

  FadeDownPal;
  VideoMode($10);
  ShowLOGO;
  ShowPICTURE;
  MoveSTARS;
  VideoMode($03);

  { Show logo }
  ASM
    MOV AX, 0B800h
    MOV ES, AX
    XOR DI, DI
    MOV SI, OFFSET Logo
    MOV CX, 4000 / 2
    REP MOVSW
    MOV AX, 040h
    MOV ES, AX
    MOV AL, 25
    MOV ES:[$50], AL  { Cursor X }
    MOV AL, 23
    MOV ES:[$51], AL  { Cursor Y }
  END;

  { Decode copyright msg }
  RandSeed := Length(Copyright) + 48;
  FOR Index := 1 TO Length(Copyright) DO
    Copyright[Index] := Chr(Byte(Copyright[Index]) XOR Random(255) XOR $7A);

  { Show copyright msg }
  ASM
   MOV SI, OFFSET Copyright
   XOR CX, CX
   MOV CL, DS:[SI]
   INC SI
 @Loop:
   LODSB
   MOV AH, 2
   MOV DL, AL
   INT 21h
   LOOP @Loop
  END;
  { End of program }
END.
