
{----------------------------- CONSTANTS --------------------------------}
CONST
  BitMasc: ARRAY[0..7] OF Byte = ($80,$40,$20,$10,$8,$4,$2,$1);
  FontX  = 8;
  FontY  = 14;
  Max_X  = 640 - 1;
  Max_Y  = 350 - 1;
  PictX  = 460;
  PictY  = 130;
  Max_X_DIV_2 = Max_X DIV 2;
  Max_Y_DIV_2 = Max_Y DIV 2;



{-------------------------------- TYPES ---------------------------------}
TYPE
  PFont = ^TFont;
  TFont = ARRAY[0..255,1..FontY] OF Byte;

  TScrChar = RECORD
               Ch:Char;
               Attr:Byte;
             END;
  TPoint   = RECORD
               X:Integer;
               Y:Integer;
               OnScreen:Boolean;
             END;
  TPoint3D = RECORD
               X:Integer;
               Y:Integer;
               Z:Integer;
               OnScreen:Boolean;
             END;
  TRgb     = RECORD
               Red:Byte;
               Green:Byte;
               Blue:Byte;
             END;

  TPal     = ARRAY[0..255] OF TRgb;
  TScreen  = ARRAY[1..2000] OF TScrChar;
  TPoints  = ARRAY[1..nOfPoints] OF TPoint;
  TPoints3D= ARRAY[1..nOfPoints] OF TPoint3D;





{----------------------------- VARIABLES --------------------------------}
VAR
       Logo : TScreen ABSOLUTE Friday13th_LOGO;
   Font8x14 : PFont;
      Index : Byte;





{----------------------------- PROCEDURES -------------------------------}
 PROCEDURE VideoMode(Mode:Word); INLINE($58/$CD/$10);
 FUNCTION FAttr(Attr:Word):Byte; INLINE($58/$24/$0F);
 FUNCTION BAttr(Attr:Word):Byte; INLINE($58/$B1/$04/$24/$70/$D2/$E8);


 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 FUNCTION KeyPressed: Boolean; ASSEMBLER;
 ASM
   MOV AH,1
   INT 16H
   MOV AL, True
   JNZ @End
   MOV AL, False
 @End:
 END;

 FUNCTION GetFontAddress:Pointer; ASSEMBLER;
 ASM
  PUSH BP
  MOV AX, $1130
  MOV BH, 2             { Get address of 8x14 font table }
  INT 10H
  MOV DX, ES            { Segment }
  MOV AX, BP            { Offset }
  POP BP
 END;

 PROCEDURE PutPixel(X,Y:Word; Color:Byte); ASSEMBLER;
 ASM
   MOV DX, $3CE
   XOR AL, AL
   MOV AH, Color
   AND AH, $0F
   OUT DX, AX
   MOV AX, $0F01
   OUT DX, AX
   MOV AL, $08
   OUT DX, AL

   MOV ES, SegA000
   MOV BX, X
   MOV CX, BX
   MOV AX, 80
   MUL Y;
   SHR BX, 1
   SHR BX, 1
   SHR BX, 1
   ADD BX, AX
   AND CL, $07
   MOV AL, $80
   SHR AL, CL
   MOV DX, $3CF
   OUT DX, AL
   MOV AH, $FF
   OR ES:[BX],AH
 END;

 FUNCTION GetPixel(X,Y:Word):Byte; ASSEMBLER;
 ASM
   MOV  AX, 80
   MUL  y
   MOV  SI, x
   MOV  CX, SI
   SHR  SI, 1
   SHR  SI, 1
   SHR  SI, 1
   ADD  SI, AX
   AND  CL, $07
   XOR  CL, $07
   MOV  CH, 1
   SHL  CH, CL

   MOV  ES, SegA000
   MOV  DX, $03CE
   MOV  AX, 772
   XOR  BL, BL
 @Gp1:
   OUT  DX, AX
   MOV  BH, ES:[SI]
   AND  BH, CH
   NEG  BH
   ROL  BX, $0001
   DEC  AH
   JGE  @Gp1
   MOV  AL, BL
 END;

 PROCEDURE GetPal(VAR APal:TPal); ASSEMBLER;
 ASM
   LES  DI, APal
   MOV  CX, 256 * 3

   MOV  DX, 03C7h
   MOV  AL, 0
   OUT  DX, AL
   MOV  DX, 03C9h
 @Loop:
   IN   AL, DX
   STOSB
   LOOP @Loop
 END;


 PROCEDURE FadeDownPal;
 VAR I,Intensity:Byte; Pal:TPal;
 BEGIN
   GetPal(Pal);
   FOR Intensity := 63 DOWNTO 0 DO
   BEGIN
     VRetrace;
     Port[$3C8] := $00;
     FOR I := 0 TO 255 DO
     BEGIN
       Port[$3C9] := Pal[I].Red   * Intensity DIV 64;
       Port[$3C9] := Pal[I].Green * Intensity DIV 64;
       Port[$3C9] := Pal[I].Blue  * Intensity DIV 64;
     END;
   END;
 END;


 PROCEDURE WriteXY(X,Y:Byte; Color:Byte; C:Char);
 VAR BackAttr:Byte;

   PROCEDURE BIOS_WriteCharXY(X,Y,Color:Byte; C:Char); NEAR; ASSEMBLER;
   ASM
     MOV AH,2; MOV DL,X; MOV DH,Y; INT 10h                 { Move cursor }
     MOV AH,0Ah; MOV AL,C; MOV BL,Color; MOV CX,1; INT 10h { Print char  }
   END;

 BEGIN
   BackAttr := BAttr(Color);
   IF (C=' ') AND (BackAttr=0) THEN Exit;
   IF (C='') THEN BackAttr := 0;
   IF (BackAttr <> 0) THEN
    BEGIN
      Color := (Color OR $80) XOR BackAttr;
      BIOS_WriteCharXY(X,Y,BackAttr,'');
    END;
   BIOS_WriteCharXY(X,Y,Color,C);
 END;






{---------------------------------------------------------------------------}
PROCEDURE ShowLOGO;
VAR I,R,Z:Byte; Off,Off2:Integer;
BEGIN
  FOR I := 79 DOWNTO 40 DO
   FOR R := 24 DOWNTO 0 DO
    BEGIN
      Z := 79-I;
      Off := (R * 80 + I) + 1;
      Off2:= (R * 80 + Z) + 1;
      WriteXY(I,R,Logo[Off].Attr,Logo[Off].Ch);
      WriteXY(Z,R,Logo[Off2].Attr,Logo[Off2].Ch);
    END;
END;




(*
{------ Write text ------}
CONST
  OldColor: Byte = 0;

 PROCEDURE PSet(X,Y,Color:Word); ASSEMBLER;
 ASM
   XOR AL, AL
   MOV AH, Color.Byte
   CMP OldColor, AH
   JE @PutPixel
   MOV DX, $3CE
   AND AH, $0F
   OUT DX, AX
   MOV AX, $0F01
   OUT DX, AX
   MOV AL, $08
   OUT DX, AL
   MOV AH, Color.Byte
   MOV OldColor, AH
 @PutPixel:
   MOV ES, SegA000
   MOV BX, X
   MOV CX, BX
   MOV AX, 80
   MUL Y
   SHR BX, 1;
   SHR BX, 1;
   SHR BX, 1;
   ADD BX, AX
   AND CL, $07
   MOV AL, $80
   SHR AL, CL
   MOV DX, $3CF
   OUT DX, AL
   MOV AH, $FF
   OR ES:[BX],AH
 END;

 PROCEDURE WriteXY(X,Y:Word; Color:Byte; Ch:Char);
 VAR I,R,D:Byte; Fore,Back:Byte;
 BEGIN
   Fore := FAttr(Color);
   Back := BAttr(Color);
   IF (Ch = ' ') AND (Back=0) THEN Exit;
   IF (Ch = '') THEN Back := 0;
   FOR I := 1 TO FontY DO
   BEGIN
     D := Font8x14^[Ord(Ch),I];
     FOR R := 0 TO 7 DO
     BEGIN
       IF (D AND BitMasc[R]) = BitMasc[R]
         THEN PSet(X,Y,Fore)
         ELSE IF Back <> 0
                THEN PSet(X,Y,Back);
       Inc(X);
     END;
     Inc(Y);
     Dec(X,8)
   END;
 END;

{---------------------------------------------------------------------------}
PROCEDURE ShowLOGO;
VAR I,R,Z:Byte; Off,Off2:Integer;
BEGIN
  FOR I := 79 DOWNTO 40 DO
   FOR R := 24 DOWNTO 0 DO
    BEGIN
      Z := 79-I;
      Off := (R * 80 + I) + 1;
      Off2:= (R * 80 + Z) + 1;
      WriteXY(i*8,r*FontY,Logo[Off].Attr,Logo[Off].Ch);
      WriteXY(z*8,r*FontY,Logo[Off2].Attr,Logo[Off2].Ch);
    END;
END;




  FUNCTION OK(TempX,TempY:Word):Boolean;
  VAR
    hardX,hardY,
    softX,softY,
    Symbol,Curr  : Byte;
    Off          : Integer;
    O_K          : Boolean;

  BEGIN
    OK := True;
    hardX := TempX DIV FontX;
    hardY := TempY DIV FontY;
    softX := TempX MOD FontX;
    softY := TempY MOD FontY;
    Off := hardY*80+hardX+1;
    Symbol := Ord(Logo[Off].Ch);
    Curr := Font8x14^[Symbol,SoftY+1];
    O_K := (Curr AND BitMasc[SoftX]) <> BitMasc[SoftX];
    IF (TempX > 460) AND (TempX < 582) AND
       (TempY > 130) AND (TempY < 265)
         THEN BEGIN
                softX := TempX - 460;
                softY := TempY - 130;
                O_K := (Pict[Pred(softX) * PictureY + softY]) = 0;
              END;
    OK := O_K;
  END;
*)